diff --git a/src/proc.c b/src/proc.c
index 0640e86144..564c0c682d 100644
--- a/src/proc.c
+++ b/src/proc.c
@@ -50,6 +50,7 @@ closure_setup(mrb_state *mrb, struct RProc *p, int nlocals)
   else {
     e = mrb->c->ci->env;
   }
+  mrb_write_barrier(mrb, (struct RBasic*)e);
   p->env = e;
 }
 
